%define _sysconfdir    /etc/ircd
%define _localstatedir /var/lib/ircd

Summary: Internet Relay Chat Server
Name: ircd-hybrid
Version: 7.0
Release: 5.4AX
License: GPL
Group: System Environment/Daemons
Source0: http://dl.sf.net/ircd-hybrid/ircd-hybrid-%{version}.tgz
Source1: %{name}.init
Source2: %{name}.sysconfig
Patch0: %{name}-config.patch
Patch1: %{name}-change_uid.patch
Patch2: %{name}-opt.patch
Patch3: http://www.ircd-hybrid.org/diff/unreg_limit.diff
URL: http://www.ircd-hybrid.org/
BuildRequires: autoconf, automake, bison, flex
BuildRequires: openssl-devel >= 0.9.7, zlib-devel, gettext
Requires(pre): /usr/bin/id, /usr/sbin/useradd, /usr/sbin/groupadd
Requires(post):    /sbin/chkconfig
Requires(preun):/sbin/chkconfig
Requires(postun): /usr/sbin/userdel
Requires(postun): /usr/sbin/groupdel
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Obsoletes: ircd <= 2.10.3p3

%description
Ircd-hybrid is an advanced IRC server which is most commonly used on the
EFNet IRC network. It is fast, reliable, and powerful.

Available rpmbuild rebuild options :
--with : ipv6

%prep
%setup -q
%patch0 -p1 -b .config
%patch1 -p1 -b .uid
%patch2 -p1 -b .opt
pushd src
%patch3 -p0 -b .unreg
popd

%build
%configure \
    --enable-zlib \
    %{?_with_ipv6:--enable-ipv6} \
    --enable-small-net \
    --enable-ssl \
    --with-nicklen=32 \
    --with-maxclients=512
make

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_var}/log/ircd
mkdir -p %{buildroot}%{_localstatedir}
mkdir -p %{buildroot}%{_libdir}/ircd/{modules/autoload,tools,help}

install -m 755 -D src/ircd %{buildroot}%{_sbindir}/ircd
install -m 755 -D servlink/servlink %{buildroot}%{_sbindir}/servlink
install -m 600 -D doc/simple.conf    %{buildroot}%{_sysconfdir}/ircd.conf
install -m 644 -D doc/ircd.8 %{buildroot}%{_mandir}/man8/ircd.8
install -m 755 -D %{SOURCE1} %{buildroot}/etc/rc.d/init.d/ircd
install -m 640 -D %{SOURCE2} %{buildroot}/etc/sysconfig/ircd

cd modules
    install -m 755 *.so %{buildroot}%{_libdir}/ircd/modules/autoload
    cd core
        install -m 755 *.so %{buildroot}%{_libdir}/ircd/modules
    cd ..
cd ..

cd tools
    for i in convertconf convertilines convertklines encspeed mkkeypair mkpasswd untabify viconf; do
        install -m 755 $i %{buildroot}%{_libdir}/ircd/tools/$i
    done
cd ..

cd help
    cp -rf opers users %{buildroot}%{_libdir}/ircd/help/
cd ..

%clean
rm -rf %{buildroot}

%pre
if [ -n "`id -g ircd 2>/dev/null`" ]; then
       if [ "`id -g ircd 2>/dev/null`" != "79" ]; then
           echo "Error: group ircd doesn't have gid=79. Correct this before installing ircd." 1>&2
           exit 1
       fi
else
       /usr/sbin/groupadd -f -g 79 ircd 2>/dev/null
fi
if [ -n "`id -u ircd 2>/dev/null`" ]; then
       if [ "`id -u ircd`" != "79" ]; then
           echo "Error: user ircd doesn't have uid=79. Correct this before installing ircd." 1>&2
           exit 1
       fi
else
       /usr/sbin/useradd -g ircd -d /etc/ircd -u 79 -c "IRC service account" -s /bin/true ircd 2> /dev/null
fi

%post
if [ "$1" = "1" ]; then
    /sbin/chkconfig --add ircd
    /sbin/chkconfig ircd off
fi

%preun
if [ "$1" = "0" ]; then
    /sbin/service ircd stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del ircd
fi

%postun
if [ "$1" = "0" ]; then
    /usr/sbin/userdel ircd 2>/dev/null || :
    /usr/sbin/groupdel ircd 2>/dev/null || :
else
    /sbin/service ircd condrestart > /dev/null 2>&1 || :
fi

%files
%defattr(-, root, root, 0755)
%doc doc/{*.txt,*.conf,server-version-info,technical}
%doc RELNOTES ChangeLog Hybrid-team BUGS TODO
%{_sbindir}/*
%attr(770,root,ircd) %dir %{_sysconfdir}
%attr(660,ircd,ircd) %config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/ircd.conf
/etc/rc.d/init.d/ircd
/etc/sysconfig/ircd
%{_libdir}/ircd
%attr(770,root,ircd) %dir %{_var}/log/ircd
%attr(770,root,ircd) %dir %{_localstatedir}
%{_mandir}/man*/*

%changelog
* Wed Aug 31 2005 Shiro Yamada <shiro@miraclelinux.com> 7.0-5.4AX
- rebuild for Asianux 2.0

* Wed Jul  7 2004 Shiro Yamada <shiro@miraclelinux.com> 7.0-5.3AX
- applied a patch which fixes a low-bandwidth DoS vulnerability

* Fri Jun  4 2004 Shiro Yamada <shiro@miraclelinux.com> 7.0-5.2AX
- disabled ircd at the first installation

* Fri Apr 30 2004 Shiro Yamada <shiro@miraclelinux.com> 7.0-5.1AX
- rebuild for Asianux 1.0

* Mon Feb 16 2004 Matthias Saou <http://freshrpms.net/> 7.0-5.fr
- Adapt the great spec file from PLD.
- Rewrite the init script for Fedora / YDL.

